#!/usr/bin/env python

"""
A console-based calculator module
"""

import math

# main menu for the calculator
def mainMenu():
	n = -1
	
	print "Welcome to the Calculator"
	
	while n != 0:
		print "1. Basic Math Functions"
		print "2. Scientific Functions"
		print "3. Bitwise Functions"
		print "4. List Functions"
		print "5. Date Functions"
		print "6. Unit Conversions"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			basicMenu()
		elif n == 2:
			scientificMenu()
		elif n == 3:
			bitwiseMenu()
		elif n == 4:
			listMenu()
		elif n == 5:
			dateMenu()
		elif n == 6:
			conversionMenu()
			
		print
			
	exit(0)

# menu for basic math functions			
def basicMenu():
	n = -1
	
	while n != 0:
		print "1. x + y"
		print "2. x - y"
		print "3. x * y"
		print "4. x / y"
		print "5. Negate x"
		print "6. 1/x"
		print "7. x / y --> %"
		print "8. Square Root of x"
		print "9. Main Menu"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			print "x + y"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print add(x, y)
		elif n == 2:
			print "x - y"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print subtract(x, y)
		elif n == 3:
			print "x * y"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print multiply(x, y)
		elif n == 4:
			print "x / y"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print divide(x, y)
		elif n == 5:
			print "Negate x"
			x = input("Enter x: ")
			print negate(x)
		elif n == 6:
			print "1/x"
			x = input("Enter x: ")
			print invert(x)
		elif n == 7:
			print "x / y --> %"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print percent(x, y)
		elif n == 8:
			print "Square Root of x"
			x = input("Enter x: ")
			print sqrt(x)
		elif n == 9:
			mainMenu()
		
		print
		
	exit(0)

# menu for scientific functions
def scientificMenu():
	n = -1
	
	while n != 0:
		print "1. Basic Math Functions"
		print "2. Algebraic Functions"
		print "3. Exponential and Logarithmic Functions"
		print "4. Trignometric Functions"
		print "5. Inverse Trignometric Functions"
		print "6. Convert Degrees and Radians"
		print "7. View Constants"
		print "8. Main Menu"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			basicMenu()
		elif n == 2:
			algebraicMenu()
		elif n == 3:
			expMenu()
		elif n == 4:
			trigMenu()
		elif n == 5:
			inverseMenu()
		elif n == 6:
			degRadMenu()
		elif n == 7:
			constantsMenu()
		elif n == 8:
			mainMenu()
		
		print
		
	exit(0)

# menu for algebraic functions
def algebraicMenu():
	n = -1
	
	while n != 0:
		print "1. x^2"
		print "2. x^3"
		print "3. x^y"
		print "4. Square Root of x"
		print "5. Cube Root of x"
		print "6. yth Root of x"
		print "7. x!"
		print "8. x mod y"
		print "9. Integer Part of x"
		print "10. Decimal Part of x"
		print "11. Back"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			print "x^2"
			x = input("Enter x: ")
			print square(x)
		elif n == 2:
			print "x^3"
			x = input("Enter x: ")
			print cube(x)
		elif n == 3:
			print "x^y"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print pow(x, y)	
		elif n == 4:
			print "Square Root of x"
			x = input("Enter x: ")
			print sqrt(x)
		elif n == 5:
			print "Cube Root of x"
			x = input("Enter x: ")
			print cubeRoot(x)
		elif n == 6:
			print "yth Root of x"
			x = input("Enter x: ")
			y = input("Enter y: ")	
			print ythRoot(x, y)
		elif n == 7:
			print "x!"
			x = input("Enter x: ")
			print factorial(x)
		elif n == 8:
			print "x mod y"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print modulo(x, y)
		elif n == 9:
			print "Integer Part of x"
			x = input("Enter x: ")
			print integer(x)
		elif n == 10:
			print "Decimal Part of x"
			x = input("Enter x: ")
			print decimal(x)
		elif n == 11:
			scientificMenu()
		
		print
		
	exit(0)

# menu for exponential and logarithmic functions
def expMenu():
	n = -1
	
	while n != 0:
		print "1. 10^x"
		print "2. log x"
		print "3. e^x"
		print "4. ln x"
		print "5. Back"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			print "10^x"
			x = input("Enter x: ")
			print powerTen(x)
		elif n == 2:
			print "log x"
			x = input("Enter x: ")
			print log(x)
		elif n == 3:
			print "e^x"
			x = input("Enter x: ")
			print exp(x)
		elif n == 4:
			print "ln x"
			x = input("Enter x: ")
			print ln(x)
		elif n == 5:
			scientificMenu()
		
		print
		
	exit(0)

# menu for trignometric functions
def trigMenu():
	n = -1
	
	while n != 0:
		print "1. sin x"
		print "2. cos x"
		print "3. tan x"
		print "4. sinh x"
		print "5. cosh x"
		print "6. tanh x"
		print "7. Back"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			print "sin x"
			x = input("Enter x: ")
			print sin(x)
		elif n == 2:
			print "cos x"
			x = input("Enter x: ")
			print cos(x)
		elif n == 3:
			print "tan x"
			x = input("Enter x: ")
			print tan(x)
		elif n == 4:
			print "sinh x"
			x = input("Enter x: ")
			print sinh(x)
		elif n == 5:
			print "cosh x"
			x = input("Enter x: ")
			print cosh(x)
		elif n == 6:
			print "tanh x"
			x = input("Enter x: ")
			print tanh(x)
		elif n == 7:
			scientificMenu()
		
		print
		
	exit(0)

# menu for inverse trignometric functions
def inverseMenu():
	n = -1
	
	while n != 0:
		print "1. arcsin x"
		print "2. arccos x"
		print "3. arctan x"
		print "4. arcsinh x"
		print "5. arccosh x"
		print "6. arctanh x"
		print "7. Back"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			print "arcsin x"
			x = input("Enter x: ")
			print arcsin(x)
		elif n == 2:
			print "arccos x"
			x = input("Enter x: ")
			print arccos(x)
		elif n == 3:
			print "arctan x"
			x = input("Enter x: ")
			print arctan(x)
		elif n == 4:
			print "arcsinh x"
			x = input("Enter x: ")
			print arcsinh(x)
		elif n == 5:
			print "arccosh x"
			x = input("Enter x: ")
			print arccosh(x)
		elif n == 6:
			print "arctanh x"
			x = input("Enter x: ")
			print arctanh(x)
		elif n == 7:
			scientificMenu()
		
		print
		
	exit(0)

# menu for converting between degrees and radians
def degRadMenu():
	n = -1
	
	while n != 0:
		print "1. Convert Degrees to Radians"
		print "2. Convert Radians to Degrees"
		print "3. Back"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			print "Convert Degrees to Radians"
			x = input("Enter x: ")
			print radian(x)
		elif n == 2:
			print "Convert Radians to Degrees"
			x = input("Enter x: ")
			print degree(x)
		elif n == 3:
			scientificMenu()
		
		print
		
	exit(0)

# menu for constants
def constantsMenu():
	n = -1
	
	while n != 0:
		print "1. pi"
		print "2. e"
		print "3. Back"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
			
		if n == 1:
			print "pi"
			print pi()
		elif n == 2:
			print "e"
			print e()
		elif n == 3:
			scientificMenu()
		
		print
		
	exit(0)

# menu for bitwise functions
def bitwiseMenu():
	n = -1
	
	while n != 0:
		print "1. NOT x"
		print "2. x AND y"
		print "3. x OR y"
		print "4. x XOR y"
		print "5. x left shift y times"
		print "6. x right shift y times"
		print "7. x rotate left"
		print "8. x rotate right"
		print "9. x mod y"
		print "10. Base Conversions"
		print "11. Main Menu"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			print "NOT x"
			x = input("Enter x: ")
			print NOT(x)
		elif n == 2:
			print "x AND y"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print AND(x, y)
		elif n == 3:
			print "x OR y"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print OR(x, y)
		elif n == 4:
			print "x XOR y"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print XOR(x, y)
		elif n == 5:
			print "x left shift y times"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print leftShift(x, y)
		elif n == 6:
			print "x right shift y times"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print rightShift(x, y)
		elif n == 7:
			print "x rotate left"
			x = input("Enter x: ")
			print rotateLeft(x)
		elif n == 8:
			print "x rotate right"
			x = input("Enter x: ")
			print rotateRight(x)
		elif n == 9:
			print "x mod y"
			x = input("Enter x: ")
			y = input("Enter y: ")
			print modulo(x, y)
		elif n == 10:
			print baseConversion()
		elif n == 11:
			mainMenu()
			
		print
	
	exit(0)
	
# converts a number to the base of the user's choice
def baseConversion():
	n = -1
	x = input("Enter your number: ")
	
	while True:
		print "What base would you like to convert it to?"
		print "1. Binary"
		print "2. Octal"
		print "3. Decimal"
		print "4. Hexadecimal"
		n = input("Please enter your selection: ")
		
		if n == 1:
			return bin(x)
		elif n == 2:
			return oct(x)
		elif n == 3:
			return x
		elif n == 4:
			return hex(x)
	
# menu for list functions	
def	listMenu():
	n = -1
	ls = input("Please enter a list: ")
	
	if type(ls) != list:
		raise TypeError("ERROR: Input was not a list")
	
	ls.sort()
	
	while n != 0:
		print "Current list: " + str(ls)
		print "1. Add a value to the list"
		print "2. Remove a value from the list"
		print "3. Make a new list"
		print "4. Mean, Median, and Mode"
		print "5. Sum of Values"
		print "6. Product of Values"
		print "7. Standard Deviation"
		print "8. Variance"
		print "9. Main Menu"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			x = input("Enter the new value: ")
			ls.append(x)
			ls.sort()
		elif n == 2:
			x = input("Enter the value to remove: ")
			ls.remove(x)
		elif n == 3:
			ls2 = input("Enter the new list: ")
			if type(ls2) != list:
				raise TypeError("ERROR: Input was not a list")
			ls = ls2
			ls.sort()
		elif n == 4:
			print average(ls)
		elif n == 5:
			print sum(ls)
		elif n == 6:
			print product(ls)
		elif n == 7:
			print stdDeviation(ls)
		elif n == 8:
			print variance(ls)
		elif n == 9:
			mainMenu()
		
		print
	
	exit(0)
	
# menu for date functions
def dateMenu():
	n = -1
	
	while n != 0:
		print "1. View Calendar"
		print "2. Day of Week"
		print "3. Difference Between Dates"
		print "4. Add or Subtract Days"
		print "5. Today's Date"
		print "6. Main Menu"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			year = input("Please enter a year: ")
			month = input("Please enter a month (Enter 0 to print entire year): ")
			print_calender(year, month)
		elif n == 2:
			year = input("Please enter a year: ")
			month = input("Please enter a month: ")
			day = input("Please enter a day: ")
			x = day_of_week(day, month, year)
			
			names = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]
			print names[x]
		elif n == 3:
			year = input("Please enter first year: ")
			month = input("Please enter first month: ")
			day = input("Please enter first day: ")
			year2 = input("Please enter second year: ")
			month2 = input("Please enter second month: ")
			day2 = input("Please enter second day: ")
			print date_difference(year, month, day, year2, month2, day2)
		elif n == 4:
			year = input("Please enter a year: ")
			month = input("Please enter a month: ")
			day = input("Please enter a day: ")
			x = input("Please enter the number of days off (Use negative for days prior): ")
			print addsub_date(year, month, day, x)
		elif n == 5:
			print today()
		elif n == 6:
			mainMenu()
		
		print
		
	exit(0)
	
# menu for doing conversions between units
def conversionMenu():
	n = -1
	
	while n != 0:
		print "1. Angle"
		print "2. Area"
		print "3. Energy"
		print "4. Length"
		print "5. Power"
		print "6. Pressure"
		print "7. Temperature"
		print "8. Time"
		print "9. Velocity"
		print "10. Volume"
		print "11. Weight/Mass"
		print "12. Main Menu"
		n = input("Please enter your selection (Enter 0 to exit): ")
		print
		
		if n == 1:
			angle()
		elif n == 2:
			area()
		elif n == 3:
			energy()
		elif n == 4:
			length()
		elif n == 5:
			power()
		elif n == 6:
			pressure()
		elif n == 7:
			temperature()
		elif n == 8:
			time()
		elif n == 9:
			velocity()
		elif n == 10:
			volume()
		elif n == 11:
			weightMass()
		elif n == 12:
			mainMenu()
			
		print
			
	exit(0)

# returns x + y
def add(x, y):
	return x + y

# returns x - y
def subtract(x, y):
	return x - y

# returns x * y
def multiply(x, y):
	return x * y

# returns x / y
# throws an error if y = 0
def divide(x, y):
	if y == 0:
		raise ValueError("ERROR: y must not be zero")
	
	x = float(x)
	return x / y

# returns -x
def negate(x):
	return -x

# returns 1/x
# throws an error if x = 0
def invert(x):
	if x == 0:
		raise ValueError("ERROR: x must not be zero")
	
	x = float(x)
	return 1 / x

# returns x / y as a percentage
# throws an error if y = 0
def percent(x, y):
	if y == 0:
		raise ValueError("ERROR: y must not be zero")
	
	x = float(x)
	return x / y * 100

# returns square root of x
def sqrt(x):
	return x ** (1.0/2)

# returns x^2
def square(x):
	return x ** 2

# returns x^3
def cube(x):
	return x ** 3

# returns x^y
def pow(x, y):
	return x ** y

# returns cube root of x
def cubeRoot(x):
	return x ** (1.0/3)

# returns the yth root of x
# throws and error if y = 0
def ythRoot(x, y):
	if y == 0:
		raise ValueError("ERROR: y must not be zero")
	
	return x ** (1.0/y)

# returns x!
# throws an error if x < 0
def factorial(x):
	if x < 1:
		raise ValueError("ERROR: x must be nonnegative")
	
	n = 1
	
	for i in range(1, x + 1):
		n = n * i
		
	return n

# returns x mod y
# throws an error if y = 0
def modulo(x, y):
	if y == 0:
		raise ValueError("ERROR: y must not be 0")
	
	return x % y

# returns the integer part of x
def integer(x):
	return math.floor(x)

# returns the decimal part of x
def decimal(x):
	return x - math.floor(x)

# returns 10^x
def powerTen(x):
	return 10 ** x

# returns log x
# throws an error if x <= 0
def log(x):
	if x <= 0:
		raise ValueError("ERROR: x must be positive")
	
	return math.log10(x)

# returns e^x
def exp(x):
	return math.exp(x)

# returns ln x
# throws an error if x <= 0
def ln(x):
	if x <= 0:
		raise ValueError("ERROR: x must be positive")
	
	return math.log(x)

# returns sin x
def sin(x):
	return math.sin(x)

# returns cos x
def cos(x):
	return math.cos(x)

# returns tan x
def tan(x):
	return math.tan(x)

# returns sinh x
def sinh(x):
	return math.sinh(x)

# returns cosh x
def cosh(x):
	return math.cosh(x)

# returns tanh x
def tanh(x):
	return math.tanh(x)

# returns arcsin x
def arcsin(x):
	return math.asin(x)

# returns arccos x
def arccos(x):
	return math.acos(x)

# returns arctan x
def arctan(x):
	return math.atan(x)

# returns arcsinh x
def arcsinh(x):
	return math.asinh(x)

# returns arccosh x
def arccosh(x):
	return math.acosh(x)

# returns arctanh x
def arctanh(x):
	return math.atanh(x)

# returns decimal approximation of pi
def pi():
	return math.pi

# returns decimal approximation of e
def e():
	return math.e

# converts x from degrees to radians
def radian(x):
	return math.radians(x)

# converts x from radians to degrees
def degree(x):
	return math.degrees(x)

# returns the bitwise NOT of x
def NOT(x):
	return ~x

# returns the bitwise AND of x and y
def AND(x, y):
	return x & y

# returns the bitwise OR of x and y
def OR(x, y):
	return x | y

# return the bitwise XOR of x and y
def XOR(x, y):
	return x ^ y

# returns x left shifted y times
def leftShift(x, y):
	return x << y

# returns x right shifted y times
def rightShift(x, y):
	return x >> y		

# returns x bitwise rotated to the left
# x is treated as a 32 bit number
def rotateLeft(x):
	return x << 1 | x >> 31
	
# returns x bitwise rotated to the left
# x is treated as a 32 bit number
def rotateRight(x):
	return x >> 1 | x << 31

# returns the mean, median, and mode of the list as a list
def average(x):
	ls = []
	sum = 0
	count = 0
	max = 0
	ls2 = []
	
	for i in x:
		sum += i
		count += 1
		
	ls.append("Mean: " + str(sum / float(count)))
	
	if count % 2 == 1:
		ls.append("Median: " + str(x[count / 2]))
	else:
		ls.append("Median: " + str((x[(count / 2) - 1] + x[count / 2]) / 2.0))
		
	for i in x:
		if x.count(i) > max:
			max = x.count(i)
	
	for i in x:
		if x.count(i) == max:
			if ls2.count(i) == 0:
				ls2.append(i)
			
	ls.append("Mode(s): " + str(ls2))
	
	return ls

# returns the product of the values in the list
def product(x):
	product = 1
	
	for i in x:
		product *= i
		
	return product

# returns the variance of the values of the list
def variance(x):
	sum = 0
	count = 0
	ls = []
	
	for i in x:
		sum += i
		count += 1
		
	mean = sum / float(count)
	
	for i in x:
		ls.append((i - mean) ** 2)
	
	sum = 0
	
	for i in ls:
		sum += i
	
	return sum / float(count)

# returns the standard deviation of the values of the list
def stdDeviation(x):	
	return variance(x) ** 0.5

# returns a value from 0 to 6 inclusive representing the day of the week
# given the day, month, and year
# 0 corresponds to Sunday, 1 to Monday, and so on
def day_of_week(day, month, year):
	if (year < 1753 or year > 2199):
		raise ValueError("Year must be between 1753 and 2199 inclusive")

	if (month < 1 or month > 12):
		raise ValueError("Month must be in between 1 and 12 inclusive")

	cal = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]    
	leap = 0
	daysOff = 0
	doomsday = 0

	if (year % 400 == 0 or (year % 4 == 0 and year % 100 != 0)):
		leap = 1

	if (leap == 1):
		cal[2] = 29
		
	if (day < 0 or day > cal[month]):
		raise ValueError("Day must be in between 1 and %d inclusive" %cal[month])
	
	if month == 1:
		if leap:
			daysOff = (day - 32 + 7) % 7
		else:
			daysOff = (day - 31 + 7) % 7
	elif month == 2:
		if leap:
			daysOff = (day - 29 + 7) % 7
		else:
			daysOff = (day - 28 + 7) % 7
	elif month == 3:
		daysOff = day % 7
	elif month == 4:
		daysOff = (17 + day) % 7
	elif month == 5:
		daysOff = (26 + day) % 7
	elif month == 6:
		daysOff = (22 + day) % 7
	elif month == 7:
		daysOff = (24 + day) % 7
	elif month == 8:
		daysOff = (20 + day) % 7
	elif month == 9:
		daysOff = (23 + day) % 7
	elif month == 10:
		daysOff = (25 + day) % 7
	elif month == 11:
		daysOff = (21 + day) % 7
	elif month == 12:
		daysOff = (23 + day) % 7

	if year / 100 == 18:
		doomsday = 5
	elif year / 100 == 19:
		doomsday = 3
	elif year / 100 == 20:
		doomsday = 2
	elif year / 100 == 21:
		doomsday = 0

	dozens = (year % 100) / 12

	remainder = year % 100 % 12

	leaps = remainder / 4

	return (daysOff + doomsday + dozens + remainder + leaps) % 7

# prints out a formatted calender of a given month in a year or the entire year
def print_calender(year, month):
	if (year < 1753 or year > 2199):
		raise ValueError("Year must be between 1753 and 2199 inclusive")

	if (month < 0 or month > 12):
		raise ValueError("Month must be in between 1 and 12 inclusive")

	if month == 0:
		for i in range(1, 13):
			print_calender_helper(year, i)
	else:     
		print_calender_helper(year, month)

# helper method for print_calender        
def print_calender_helper(year, month):
	cal = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]
	names = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"]
	s = ""

	if (year % 400 == 0 or (year % 4 == 0 and year % 100 != 0)):
		cal[2] = 29

	day = day_of_week(1, month, year)
	for i in range(day):
		s += "\t"

	print "\t\t\t" + names[month - 1]
	print "Su \tMo \tTu \tWe \tTh \tFr \tSa"
	print s,
	for i in range(1, cal[month] + 1):          
		print str(i) + "\t",
		day += 1
		if day == 7:
			day = 0
			print

	print
	print
	
# calculates the difference between two dates
def date_difference(year, month, day, year2, month2, day2):
	import datetime
	date1 = datetime.date(year, month, day)
	date2 = datetime.date(year2, month2, day2)
	
	return date2 - date1

# calculates the date x days away from the given date
def addsub_date(year, month, day, x):
	import datetime
	date = datetime.date(year, month, day)
	difference = datetime.timedelta(days = x)
	
	return date + difference

# returns today's date
def today():
	import datetime
	return datetime.date.today()
		
# convert between angle units
def angle():
	print "What unit is your value in?"
	print "1. Degree"
	print "2. Gradian"
	print "3. Radian"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		degree = float(x)
	elif n == 2:
		degree = 0.9 * x	
	elif n == 3:
		degree = 180.0 * x / math.pi
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. Degree"
	print "2. Gradian"
	print "3. Radian"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "Degrees: " + str(degree);
		print "Gradians: " + str(toGradian(degree))
		print "Radians: " + str(toRadian(degree))
	elif n == 1:
		print degree;
	elif n == 2:
		print "Gradians: " + str(toGradian(degree))
	elif n == 3:
		print "Radians: " + str(toRadian(degree))
	else:
		raise ValueError("ERROR: Invalid Selection")

# convert from degree to gradian
def toGradian(x):
	return 10.0 / 9 * x

# convert from degree to radian
def toRadian(x):
	return math.pi / 180 * x

# convert between area units
def area():	
	print "What unit is your value in?"
	print "1. Acre"
	print "2. Square Feet"
	print "3. Square Meter"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		feet = 43560 * float(x)
	elif n == 2:
		feet = float(x)	
	elif n == 3:
		feet = 10.763911 * x
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. Acre"
	print "2. Square Feet"
	print "3. Square Meter"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "Acres: " + str(toAcres(feet));
		print "Square Feet: " + str(feet)
		print "Square Meters: " + str(toMeters(feet))
	elif n == 1:
		print "Acres: " + str(toAcres(feet))
	elif n == 2:
		print "Square Feet: " + str(feet)
	elif n == 3:
		print "Square Meters: " + str(toMeters(feet))
	else:
		raise ValueError("ERROR: Invalid Selection")
	
# convert from square feet to acres
def toAcres(x):
	return 0.00002295684 * x;

# convert from square feet to square meters
def toMeters(x):
	return 0.09290304 * x;

# convert between energy units
def energy():
	print "What unit is your value in?"
	print "1. BTU"
	print "2. Calorie"
	print "3. Electron-Volts"
	print "4. Foot-Pound"
	print "5. Joule"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		joule = 1055 * float(x)
	elif n == 2:
		joule =	4.187 * x
	elif n == 3:
		joule = 1.602 * (10 ** -19) * x
	elif n == 4:
		joule = 1.356 * x
	elif n == 5:
		joule = float(x)
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. BTU"
	print "2. Calorie"
	print "3. Electron-Volts"
	print "4. Foot-Pound"
	print "5. Joule"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "BTUs: " + str(toBTUs(joule));
		print "Calories: " + str(toCalories(joule))
		print "Electron-Volts: " + str(toEV(joule))
		print "Foot-Pounds: " + str(toFP(joule))
		print "Joules: " + str(joule)
	elif n == 1:
		print "BTUs: " + str(toBTUs(joule))
	elif n == 2:
		print "Calories: " + str(toCalories(joule))
	elif n == 3:
		print "Electron-Volts: " + str(toEV(joule))
	elif n == 4:
		print "Foot-Pounds: " + str(toFP(joule))
	elif n == 5:
		print "Joules: " + str(joule)
	else:
		raise ValueError("ERROR: Invalid Selection")
	
# convert joules to BTUs
def toBTUs(x):
	return 9.481 * (10 ** -4) * x

# convert joules to calories
def toCalories(x):
	return 0.2388 * x

# convert joules to electron-volts
def toEV(x):
	return 6.242197253 * (10 ** 18) * x

# covert joules to foot-pounds
def toFP(x):
	return 0.7376 * x

# converting between length units
def length():
	print "What unit is your value in?"
	print "1. Chain"
	print "2. Fathom"
	print "3. Feet"
	print "4. Hand"
	print "5. Meter"
	print "6. Mile"
	print "7. Nautical Mile"
	print "8. Rod"
	print "9. Span"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		meter = 20.11 * x 
	elif n == 2:
		meter =	1.8288 * x
	elif n == 3:
		meter = 0.3048 * x
	elif n == 4:
		meter = 0.1016 * x
	elif n == 5:
		meter = float(x)
	elif n == 6:
		meter = 1609.34 * x
	elif n == 7:
		meter = 1852 * float(x)
	elif n == 8:
		meter = 5.029 * x
	elif n == 9:
		meter = 0.2286 * x
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. Chain"
	print "2. Fathom"
	print "3. Feet"
	print "4. Hand"
	print "5. Meter"
	print "6. Mile"
	print "7. Nautical Mile"
	print "8. Rod"
	print "9. Span"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "Chains: " + str(toChains(meter));
		print "Fathoms: " + str(toFathoms(meter))
		print "Feet: " + str(toFeet(meter))
		print "Hands: " + str(toHands(meter))
		print "Meters: " + str(meter)
		print "Miles " + str(toMiles(meter))
		print "Nautical Miles " + str(toNM(meter))
		print "Rods " + str(toRods(meter))
		print "Spans " + str(toSpans(meter))
	elif n == 1:
		print "Chains: " + str(toChains(meter))
	elif n == 2:
		print "Fathoms: " + str(toFathoms(meter))
	elif n == 3:
		print "Feet: " + str(toFeet(meter))
	elif n == 4:
		print "Hands: " + str(toHands(meter))
	elif n == 5:
		print "Meters: " + str(meter)
	elif n == 6:
		print "Miles " + str(toMiles(meter))
	elif n == 7:
		print "Nautical Miles " + str(toNM(meter))
	elif n == 8:
		print "Rods " + str(toRods(meter))
	elif n == 9:
		print "Spans " + str(toSpans(meter))
	else:
		raise ValueError("ERROR: Invalid Selection")

# convert meters to chains
def toChains(x):
	return 0.04971 * x

# convert meters to fathoms
def toFathoms(x):
	return 0.546806649 * x

# convert meters to feet
def toFeet(x):
	return 3.28083 * x

# convert meters to hands
def toHands(x):
	return 9.84251 * x

# convert meters to miles
def toMiles(x):
	return 0.00062 * x

# converts meters to nautical miles
def toNM(x):
	return 0.00053 * x

# converts meters to rods
def toRods(x):
	return 0.19883 * x

# converts meters to spans
def toSpans(x):
	return 4.374453193 * x

# converting between power units
def power():
	print "What unit is your value in?"
	print "1. BTU/minute"
	print "2. Foot-Pound/minute"
	print "3. Horsepower"
	print "4. Watt"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		watt = 17.58426666666667 * x
	elif n == 2:
		watt = 1.356 * x
	elif n == 3:
		watt = 746 * float(x)
	elif n == 4:
		watt = float(x)
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. BTU/minute"
	print "2. Foot-Pound/minute"
	print "3. Horsepower"
	print "4. Watt"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "BTUs/minute: " + str(toBTUMs(watt))
		print "Foot-Pounds/minute: " + str(toFPMs(watt))
		print "Horsepower: " + str(toHorsepower(watt))
		print "Watts: " + str((watt))
	elif n == 1:
		print "BTUs/minute: " + str(toBTUMs(watt))
	elif n == 2:
		print "Foot-Pounds/minute: " + str(toFPMs(watt))
	elif n == 3:
		print "Horsepower: " + str(toHorsepower(watt))
	elif n == 4:
		print "Watts: " + str((watt))
	else:
		raise ValueError("ERROR: Invalid Selection")
				
# convert from watts to BUTs/minute
def toBTUMs(x):
	return 0.0568690192748063 * x

# convert from watts to Foot-Pounds/minute
def toFPMs(x):
	return 0.7376 * x

# convert from watts to horsepower
def toHorsepower(x):
	return 0.001341 * x

# converting between pressure units
def pressure():
	print "What unit is your value in?"
	print "1. Atmosphere"
	print "2. Bar"
	print "3. MM Hg"
	print "4. Pascal"
	print "5. PSI"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		atm = float(x)
	elif n == 2:
		atm = 0.9872 * x
	elif n == 3:
		atm = 1.3158 * (10 ** -3) * x
	elif n == 4:
		atm = 9.869 * (10 ** -6) * x
	elif n == 5:
		atm = 0.068046 * x
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. Atmosphere"
	print "2. Bar"
	print "3. MM Hg"
	print "4. Pascal"
	print "5. PSI"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "Atmospheres: " + str(atm)
		print "Bars: " + str(toBars(atm))
		print "MM Hg: " + str(toMMHg(atm))
		print "Pascals: " + str(toPascals(atm))
		print "PSIs: " + str(toPSIs(atm))
	elif n == 1:
		print "Atmospheres: " + str(atm)
	elif n == 2:
		print "Bars: " + str(toBars(atm))
	elif n == 3:
		print "MM Hg: " + str(toMMHg(atm))
	elif n == 4:
		print "Pascals: " + str(toPascals(atm))
	elif n == 5:
		print "PSIs: " + str(toPSIs(atm))
	else:
		raise ValueError("ERROR: Invalid Selection")					

# convert from atmospheres to bars
def toBars(x):
	return 1.01295 * x

# convert from atmospheres to millimeters mercury
def toMMHg(x):
	return 760 * float(x)

# convert from atmospheres to pascals
def toPascals(x):
	return 1.01295 * (10 ** 5) * x

# convert from atmospheres to PSIs
def toPSIs(x):
	return 14.696 * x

# converting between temperature units
def temperature():
	print "What unit is your value in?"
	print "1. Celsius"
	print "2. Fahrenheit"
	print "3. Kelvin"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		celsius = float(x)
	elif n == 2:
		celsius = float(x) - 32 * 5 / 9 
	elif n == 3:
		celsius = x - 273.15 
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. Celsius"
	print "2. Fahrenheit"
	print "3. Kelvin"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "Celsius: " + str(celsius)
		print "Fahrenheit: " + str(toFahrenheit(celsius))
		print "Kelvin: " + str(toKelvin(celsius))
	elif n == 1:
		print "Celsius: " + str(celsius)
	elif n == 2:
		print "Fahrenheit: " + str(toFahrenheit(celsius))
	elif n == 3:
		print "Kelvin: " + str(toKelvin(celsius))
	else:
		raise ValueError("ERROR: Invalid Selection")					

# convert from celsius to fahrenheit
def toFahrenheit(x):
	return float(x) * 9 / 5 + 32 

# convert from celsius to kelvin
def toKelvin(x):
	return x + 273.15 

# converting between time units
def time():
	print "What unit is your value in?"
	print "1. Day"
	print "2. Hour"
	print "3. Minute"
	print "4. Second"
	print "5. Week"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		second = float(x) * 86400
	elif n == 2:
		second = float(x) * 3600
	elif n == 3:
		second = float(x) * 60
	elif n == 4:
		second = float(x)
	elif n == 5:
		second = float(x) * 604800
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. Day"
	print "2. Hour"
	print "3. Minute"
	print "4. Second"
	print "5. Week"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "Days: " + str(toDays(second))
		print "Hours: " + str(toHours(second))
		print "Minutes: " + str(toMinutes(second))
		print "Seconds: " + str(second)
		print "Weeks: " + str(toWeeks(second))
	elif n == 1:
		print "Days: " + str(toDays(second))
	elif n == 2:
		print "Hours: " + str(toHours(second))
	elif n == 3:
		print "Minutes: " + str(toMinutes(second))
	elif n == 4:
		print "Seconds: " + str(second)
	elif n == 5:
		print "Weeks: " + str(toWeeks(second))
	else:
		raise ValueError("ERROR: Invalid Selection")	
	
# convert from seconds to days
def toDays(x):
	return float(x)	/ 86400

# convert from seconds to hours
def toHours(x):
	return float(x) / 3600

# convert from seconds to minutes
def toMinutes(x):
	return float(x) / 60

# convert from seconds to weeks
def toWeeks(x):
	return float(x) / 604800

# converting between velocity units
def velocity():
	print "What unit is your value in?"
	print "1. Feet per second"
	print "2. Kilometers per hour"
	print "3. Knots"
	print "4. Mach"
	print "5. Meters per second"
	print "6. Miles per hour"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		mps = 0.3048 * x
	elif n == 2:
		mps = 0.2777777777777778 * x
	elif n == 3:
		mps = 0.5144444444444444 * x
	elif n == 4:
		mps = 340.2933 * x
	elif n == 5:
		mps = float(x)
	elif n == 6:
		mps = 0.44704 * x
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. Feet per second"
	print "2. Kilometers per hour"
	print "3. Knots"
	print "4. Mach"
	print "5. Meters per second"
	print "6. Miles per hour"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "Feet per second: " + str(toFeetPS(mps))
		print "Kilometers per hour: " + str(toKMPH(mps))
		print "Knots: " + str(toKnots(mps))
		print "Machs: " + str(toMachs(mps))
		print "Meters per second: " + str(mps)
		print "Miles per hours: " + str(toMilesPH(mps))	
	elif n == 1:
		print "Feet per second: " + str(toFeetPS(mps))
	elif n == 2:
		print "Kilometers per hour: " + str(toKMPH(mps))
	elif n == 3:
		print "Knots: " + str(toKnots(mps))
	elif n == 4:
		print "Machs: " + str(toMachs(mps))
	elif n == 5:
		print "Meters per second: " + str(mps)
	elif n == 6:
		print "Miles per hours: " + str(toMilesPH(mps))		
	else:
		raise ValueError("ERROR: Invalid Selection")
	
# convert from meters per second to feet per second
def toFeetPS(x):
	return 3.280839895013123 * x

# convert from meters per second to kilometers per hour
def toKMPH(x):
	return 3.6 * x

# convert from meters per second to knots
def toKnots(x):
	return 1.943844492440605 * x

# convert from meters per second to machs
def toMachs(x):
	return 0.0029386414601757 * x

# convert from meters per second to miles per hour
def toMilesPH(x):
	return 2.236936292054402 * x

# converting between volume units
def volume():
	print "What unit is your value in?"
	print "1. Cubic Centimeters"
	print "2. Fluid Ounce"
	print "3. Gallon"
	print "4. Liter"
	print "5. Pint"
	print "6. Quart"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		cc = float(x)
	elif n == 2:
		cc = 29.5735295625 * x
	elif n == 3:
		cc = 3785.411784 * x
	elif n == 4:
		cc = 1000 * float(x)
	elif n == 5:
		cc = 473.176473 * x
	elif n == 6:
		cc = 946.352946 * x
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. Cubic Centimeters"
	print "2. Fluid Ounce"
	print "3. Gallon"
	print "4. Liter"
	print "5. Pint"
	print "6. Quart"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "Cubic Centimeters: " + str(cc)
		print "Fluid Ounces: " + str(toFluidOunces(cc))
		print "Gallons: " + str(toGallons(cc))
		print "Liters: " + str(toLiters(cc))
		print "Pints: " + str(toPints(cc))
		print "Quarts: " + str(toQuarts(cc))	
	elif n == 1:
		print "Cubic Centimeters: " + str(cc)
	elif n == 2:
		print "Fluid Ounces: " + str(toFluidOunces(cc))
	elif n == 3:
		print "Gallons: " + str(toGallons(cc))
	elif n == 4:
		print "Liters: " + str(toLiters(cc))
	elif n == 5:
		print "Pints: " + str(toPints(cc))
	elif n == 6:
		print "Quarts: " + str(toQuarts(cc))			
	else:
		raise ValueError("ERROR: Invalid Selection")

# convert from cubic centimeters to fluid ounces
def toFluidOunces(x):
	return 0.033814022701843 * x

# convert from cubic centimeters to gallons
def toGallons(x):
	return 2.641720523581484e-4 * x

# convert from cubic centimeters to liters
def toLiters(x):
	return 0.001 * x

# convert from cubic centimeters to pints
def toPints(x):
	return 0.0021133764188652 * x

# convert from cubic centimeters to quarts
def toQuarts(x):
	return 0.0010566882094326 * x

# converting between weight/mass units
def weightMass():
	print "What unit is your value in?"
	print "1. Carat"
	print "2. Gram"
	print "3. Kilogram"
	print "4. Ounce"
	print "5. Pound"
	print "6. Ton"
	print "7. Stone"
	n = input("Enter your selection: ")
	
	x = input("Enter your value: ")
	
	if n == 1:
		kg = 0.0002 * x
	elif n == 2:
		kg = 0.001 * x
	elif n == 3:
		kg = float(x)
	elif n == 4:
		kg = 0.028349523125 * x
	elif n == 5:
		kg = 0.45359237 * x
	elif n == 6:
		kg = 907.18474 * x
	elif n == 7:
		kg = 6.35029318 * x
	else:
		raise ValueError("ERROR: Invalid Selection")
	
	print "What unit would you like to convert to?"
	print "1. Carat"
	print "2. Gram"
	print "3. Kilogram"
	print "4. Ounce"
	print "5. Pound"
	print "6. Ton"
	print "7. Stone"
	n = input("Enter your selection (Enter 0 to print all): ")
	
	if n == 0:
		print "Carats: " + str(toCarats(kg))
		print "Grams: " + str(toGrams(kg))
		print "Kilograms: " + str(kg)
		print "Ounces: " + str(toOunces(kg))
		print "Pounds: " + str(toPounds(kg))
		print "Tons: " + str(toTons(kg))	
		print "Stones: " + str(toStones(kg))
	elif n == 1:
		print "Carats: " + str(toCarats(kg))
	elif n == 2:
		print "Grams: " + str(toGrams(kg))
	elif n == 3:
		print "Kilograms: " + str(kg)
	elif n == 4:
		print "Ounces: " + str(toOunces(kg))
	elif n == 5:
		print "Pounds: " + str(toPounds(kg))
	elif n == 6:
		print "Tons: " + str(toTons(kg))	
	elif n == 7:
		print "Stones: " + str(toStones(kg))			
	else:
		raise ValueError("ERROR: Invalid Selection")

# convert from kilograms to carats
def toCarats(x):
	return 5000 * float(x)

# convert from kilograms to grams
def toGrams(x):
	return 1000 * float(x)

# convert from kilograms to ounces
def toOunces(x):
	return 35.27396194958041 * x

# convert from kilograms to pounds
def toPounds(x):
	return 2.204622621848776 * x

# convert from kilograms to tons
def toTons(x):
	return 0.0011023113109244 * x

# convert from kilograms to stones
def toStones(x):
	return 0.1574730444177697 * x

if __name__ == '__main__':
	mainMenu()
	